<?php
/***************************************************************************
 * common.php
 * 2009-11-10
 * ForkBB Project [a fork of phpBB2]
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_FORKBB') ) die('Hacking attempt!');

// This will NOT report uninitialized variables
error_reporting  (E_ERROR | E_WARNING | E_PARSE);
// Disable magic_quotes_runtime
set_magic_quotes_runtime(0);

// Protect against session tricks
if (isset($_SESSION) && !is_array($_SESSION))
{
	die('Hacking attempt!');
}
else
{
	// Not only will array_merge give a warning if a parameter
	// is not an array, it will actually fail.
	$_SESSION = array();
}
// Unregister globals
if (@ini_get('register_globals') == '1' || strtolower(@ini_get('register_globals')) == 'on')
{
	$not_unset = array('_GET', '_POST', '_COOKIE', '_SERVER', '_SESSION', '_ENV', '_FILES', 'forkbb_root_path');
	// Merge all into one extremely huge array; unset this later
	$input = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_SESSION, $_ENV, $_FILES);
	unset($input['input']);
	unset($input['not_unset']);
	while (list($var,) = @each($input))
	{
		if (in_array($var, $not_unset)) die('Hacking attempt!');
		unset($$var);
	}
	unset($input);
}

//
// addslashes to vars if magic_quotes_gpc is off
// this is a security precaution to prevent someone
// trying to break out of a SQL statement.
//
if( !get_magic_quotes_gpc() )
{
	if( is_array($_GET) )
	{
		while( list($k, $v) = each($_GET) )
		{
			if( is_array($_GET[$k]) )
			{
				while( list($k2, $v2) = each($_GET[$k]) )
				{
					$_GET[$k][$k2] = addslashes($v2);
				}
				@reset($_GET[$k]);
			}
			else
			{
				$_GET[$k] = addslashes($v);
			}
		}
		@reset($_GET);
	}

	if( is_array($_POST) )
	{
		while( list($k, $v) = each($_POST) )
		{
			if( is_array($_POST[$k]) )
			{
				while( list($k2, $v2) = each($_POST[$k]) )
				{
					$_POST[$k][$k2] = addslashes($v2);
				}
				@reset($_POST[$k]);
			}
			else
			{
				$_POST[$k] = addslashes($v);
			}
		}
		@reset($_POST);
	}

	if( is_array($_COOKIE) )
	{
		while( list($k, $v) = each($_COOKIE) )
		{
			if( is_array($_COOKIE[$k]) )
			{
				while( list($k2, $v2) = each($_COOKIE[$k]) )
				{
					$_COOKIE[$k][$k2] = addslashes($v2);
				}
				@reset($_COOKIE[$k]);
			}
			else
			{
				$_COOKIE[$k] = addslashes($v);
			}
		}
		@reset($_COOKIE);
	}
}

//
// Define some basic configuration arrays this also prevents
// malicious rewriting of language and otherarray values via
// URI params
//
$board_config = array();
$userdata = array();
$theme = array();
$lang = array();
$gen_simple_header = FALSE;

require_once($forkbb_root_path . 'config.php');

if( !defined('FORKBB_INSTALLED') )
{
	header('Location: ' . $forkbb_root_path . 'install/install.php');
	exit;
}

require_once($forkbb_root_path . 'includes/constants.php');
//require_once($forkbb_root_path . 'includes/template.php');
require_once($forkbb_root_path . 'includes/sessions.php');
//require_once($forkbb_root_path . 'includes/auth.php');
require_once($forkbb_root_path . 'includes/index.php');
require_once($forkbb_root_path . 'db/index.php');

// We do not need this any longer, unset for safety purposes
unset($dbpasswd);

//
// Obtain and encode users IP
//
$client_ip = ( !empty($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : ( ( !empty($_ENV['REMOTE_ADDR']) ) ? $_ENV['REMOTE_ADDR'] : getenv('REMOTE_ADDR') );
$user_ip = encode_ip($client_ip);

//
// Setup forum wide options, if this fails
// then we output a CRITICAL_ERROR since
// basic forum information is not available
//
$sql = 'SELECT config_name, config_value
	FROM ' . CONFIG_TABLE;
if( !($result = $db->sql_query($sql)) )
{
	message_die(CRITICAL_ERROR, 'Could not query config information', '', __LINE__, __FILE__, $sql);
}
while ( $row = $db->sql_fetchrow($result) )
{
	$board_config[$row['config_name']] = $row['config_value'];
}

if (file_exists('install') || file_exists('contrib'))
{
	message_die(GENERAL_MESSAGE, 'Please_remove_install_contrib');
}

//
// Show 'Board is disabled' message if needed.
//
if( $board_config['board_disable'] && !defined('IN_ADMIN') && !defined('IN_LOGIN') )
{
	message_die(GENERAL_MESSAGE, 'Board_disable', 'Information');
}
